package main;

import java.awt.*;

import javax.swing.*;

import Feature.MyCharacter;

import java.awt.event.*;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;

public class Main extends JFrame implements ActionListener {

	private static final long serialVersionUID = 1L;
	public static final int SIZE = 4, TEXTFIELD_SIZE = 60;
	private static final int TIME_CONST = 1000000;

	private double dwellTime = 0, pressingTime = 0, releasingTime = -1,
			flyingTime = 0;
	String flyTimeString = "", dwellTimeString = "";

	MyCharacter ch = null, ch2 = null, ch3 = null;
	Boolean typingStarted = false;

	ArrayList<MyCharacter> password = new ArrayList<MyCharacter>();
	ArrayList<ArrayList<MyCharacter>> passwordList = new ArrayList<ArrayList<MyCharacter>>();

	JTextField tfPattern, tfPassword, tfDwellTime, tfFlyingTime;
	JButton btnClear, btnNextPassword, btnSavePattern, btnClose;

	public Main() {
		setTitle("Aplikace pro sber dat - Jan Kozlovsky");

		Container content = getContentPane();

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		content.setLayout(gridbag);

		c.fill = GridBagConstraints.NONE;
		c.weightx = 1.0;

		// Vzor hesla
		// ----------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Sem napite vzor hesla:"), c);

		// Pattern - vzor
		JPanel patternPanel = new JPanel();
		patternPanel.setLayout(new FlowLayout());
		tfPattern = new JTextField("", TEXTFIELD_SIZE - 10);
		tfPattern.setFocusable(true);
		tfPattern.setEditable(true);
		patternPanel.add(tfPattern);
		// Tlacitko pro ulozeni vzoru
		btnSavePattern = new JButton("Ulozit vzor");
		btnSavePattern.addActionListener(this);
		patternPanel.add(btnSavePattern);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(patternPanel, c);

		// Heslo
		// ----------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Sem vepite heslo:"), c);

		JPanel inputPanel = new JPanel();
		inputPanel.setLayout(new FlowLayout());
		tfPassword = new JTextField("", TEXTFIELD_SIZE);
		tfPassword.setFocusable(true);
		tfPassword.setEditable(false);
		inputPanel.add(tfPassword);
		setActionListenersForTFPASSWORD();

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(inputPanel, c);

		// Doba
		// ----------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Doba stisku (Dwell time) [ms]"), c);

		JPanel outputPanel = new JPanel();
		outputPanel.setLayout(new FlowLayout());
		tfDwellTime = new JTextField("", TEXTFIELD_SIZE);
		tfDwellTime.setEditable(false);
		outputPanel.add(tfDwellTime);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(outputPanel, c);

		// Doba mezi stisky
		// ----------------------------------------------------------------------------------------
		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		content.add(new JLabel("Doba mezi stisky (Flight  time) [ms]"), c);

		JPanel outputPanel2 = new JPanel();
		outputPanel2.setLayout(new FlowLayout());
		tfFlyingTime = new JTextField("", TEXTFIELD_SIZE);
		tfFlyingTime.setEditable(false);
		outputPanel2.add(tfFlyingTime);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(outputPanel2, c);
		// ----------------------------------------------------------------------------------------

		// Buttons
		JPanel buttonPanel = new JPanel();

		btnClear = new JButton("Vymazat heslo (je patn)");
		btnNextPassword = new JButton("Uloit a napsat jet jednou");
		btnClose = new JButton("Zavt");

		btnClear.addActionListener(this);
		btnNextPassword.addActionListener(this);
		btnClose.addActionListener(this);

		buttonPanel.setLayout(new FlowLayout());
		buttonPanel.add(btnClear);
		buttonPanel.add(btnNextPassword);
		buttonPanel.add(btnClose);

		btnNextPassword.setEnabled(false);
		btnClear.setEnabled(false);

		content.add(buttonPanel, c);

		// adjust size and position
		pack();
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension d = toolkit.getScreenSize();
		setLocation((int) (d.width - this.getSize().getWidth()) / 2,
				(int) (d.height - this.getSize().getHeight()) / 2);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setResizable(false);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				generateCSV();
			}
		});

	}

	public void setActionListenersForTFPASSWORD() {
		tfPassword.addKeyListener(new KeyListener() {

			public void keyTyped(KeyEvent arg0) {
				
			}

			public void keyReleased(KeyEvent key) {
				if (typingStarted) {
					releasingTime = getActualMiliTime();

					MyCharacter mch = null;

					if (ch != null) {
						if (key.getKeyCode() == ch.getKeyCode()) {
							mch = ch;
							ch = null;
						}
					}
					if (ch2 != null) {
						if (key.getKeyCode() == ch2.getKeyCode()) {
							mch = ch2;
							ch2 = null;
						}
					}
					if (ch3 != null) {
						if (key.getKeyCode() == ch3.getKeyCode()) {
							mch = ch3;
							ch3 = null;
						}
					}

					dwellTime = releasingTime - mch.getPressingTime();
					mch.setDwellTime(dwellTime);

					if (dwellTimeString == "") {
						dwellTimeString = Double.toString(dwellTime);
					} else {
						dwellTimeString = dwellTimeString + ", "
								+ Double.toString(dwellTime);
					}
					tfDwellTime.setText(dwellTimeString);

					password.add(mch);

					if (tfPassword.getText().equals(tfPattern.getText())) {
						tfPassword.setForeground(Color.decode("#006400"));
						btnNextPassword.setEnabled(true);
					} else {
						tfPassword.setForeground(Color.RED);
						btnNextPassword.setEnabled(false);
					}
				}
			}

			public void keyPressed(KeyEvent key) {
				typingStarted = true;

				pressingTime = getActualMiliTime();
				if (releasingTime < 0) {
					flyingTime = 0;
				} else {
					flyingTime = pressingTime - releasingTime;
				}

				MyCharacter mch = new MyCharacter(pressingTime, flyingTime, key
						.getKeyCode(), key.getKeyChar());
				if (ch == null) {
					ch = mch;
				} else {
					if (ch2 == null) {
						ch2 = mch;
					} else {
						ch3 = mch;
					}
				}

				if (flyTimeString == "") {
					flyTimeString = Double.toString(flyingTime);
				} else {
					flyTimeString = flyTimeString + ", "
							+ Double.toString(flyingTime);
				}
				tfFlyingTime.setText(flyTimeString);
			}
		});
		;

	}

	public double getActualMiliTime() {
		return System.nanoTime() / TIME_CONST;
	}

	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == btnClear)
			clear();
		else if (e.getSource() == btnNextPassword)
			nextPassword();
		else if (e.getSource() == btnSavePattern) {
			tfPassword.setEditable(true);
			tfPattern.setEditable(false);
			btnClear.setEnabled(true);
			btnSavePattern.setEnabled(false);
		} else if (e.getSource() == btnClose) {
			generateCSV();
			System.exit(0);
		}
	}

	protected void generateCSV() {
		if (passwordList.size() != 0) {
			// C:/Users/(USERNAME)/hesla.csv 
			String userHome = System.getProperty("user.home");
			String path = userHome + "/hesla.csv";
			generateCsvFile(path);
		}
	}

	protected void clear() {
		dwellTimeString = "";
		tfDwellTime.setText("");

		flyTimeString = "";
		tfFlyingTime.setText("");

		tfPassword.setText("");
		password.clear();

		tfPassword.requestFocus();

		btnNextPassword.setEnabled(false);

		releasingTime = -1;
	}

	protected void nextPassword() {
		passwordList.add(password);
		password = null;
		password = new ArrayList<MyCharacter>();

		releasingTime = -1;

		dwellTimeString = "";
		tfDwellTime.setText("");

		flyTimeString = "";
		tfFlyingTime.setText("");

		tfPassword.setText("");

		tfPassword.requestFocus();
	}

	static public void main(String args[]) {
		JFrame f = new Main();
		f.setVisible(true);
	}

	private void generateCsvFile(String sFileName) {

		try {
			FileWriter writer = new FileWriter(sFileName);

			ArrayList<MyCharacter> p = passwordList.get(0);

			for (int i = 0; i < p.size(); i++) {
				writer.append("FT" + i);
				writer.append(',');
				writer.append("DT" + i);
				// The last character
				if (i == p.size() - 1) {
					writer.append(',');
					writer.append("User");
				} else {
					writer.append(',');
				}
			}
			writer.append('\n');

			for (ArrayList<MyCharacter> password : passwordList) {

				for (int i = 0; i < password.size(); i++) {
					MyCharacter mch = password.get(i);

					writer.append(BigDecimal.valueOf(mch.getFlyingTime())
							.toPlainString());
					writer.append(',');
					writer.append(BigDecimal.valueOf(mch.getDwellTime())
							.toPlainString());
					// The last character
					if (i == password.size() - 1) {
						writer.append(',');
						writer.append("UserA");
					} else {
						writer.append(',');
					}
				}
				writer.append('\n');
			}

			writer.flush();
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}