package Function;


import org.encog.engine.network.activation.ActivationFunction;
import org.encog.ml.factory.MLActivationFactory;
import org.encog.util.obj.ActivationUtil;

public class ActivationRectifiedLinear implements ActivationFunction {

	/**
	 * The parameters.
	 */
	private final double[] params;
	
	public ActivationRectifiedLinear(){
		this.params = new double[0];
	}
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	/**
	 * {@inheritDoc}
	 */
	public final void activationFunction(final double[] x, final int start,
			final int size) {
		
		for (int i = start; i < start + size; i++) {
			if (x[i] > 0) {
				x[i] = x[i] / 2;
			} else {
				x[i] = 0;
			}
		}
		
	}
	
	
	/**
	 * @return The object cloned.
	 */
	@Override
	public final ActivationFunction clone() {
		return new ActivationRectifiedLinear();
	}
	
	public final double derivativeFunction(final double b, final double a) {
		if (b > 0) {
			return 0.5;
		} else {
			return 0;
		}

	}
	
	public final String[] getParamNames() {
		final String[] results = {};
		return results;
	}
	
	public final double[] getParams() {
		return this.params;
	}
	
	public final boolean hasDerivative() {
		return true;
	}
	
	public void setParam(final int index, final double value) {
		this.params[index] = value;
		
	}
	
	public String getFactoryCode() {
		return null;
	}

}
