package GUI;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import org.encog.Encog;
import org.encog.app.analyst.AnalystFileFormat;
import org.encog.app.analyst.EncogAnalyst;
import org.encog.app.analyst.script.AnalystScript;
import org.encog.app.analyst.script.normalize.AnalystField;
import org.encog.app.analyst.wizard.AnalystWizard;
import org.encog.app.analyst.wizard.NormalizeRange;
import org.encog.ml.MLClassification;
import org.encog.ml.MLRegression;
import org.encog.ml.data.MLData;
import org.encog.ml.data.basic.BasicMLData;
import org.encog.ml.data.versatile.NormalizationHelper;
import org.encog.neural.networks.BasicNetwork;
import org.encog.util.arrayutil.NormalizeArray;
import org.encog.util.csv.CSVFormat;
import org.encog.util.csv.ReadCSV;

import Feature.MyCharacter;

public class EnterPassword extends JFrame implements ActionListener {
	private static Boolean resit_moji_metodou;

	private static final long serialVersionUID = 1L;
	public static final int SIZE = 4, TEXTFIELD_SIZE = 60;
	private static final int TIME_CONST = 1000000;
	private double dwellTime = 0, pressingTime = 0, releasingTime = -1,
			flyingTime = 0;
	String flyTimeString = "", dwellTimeString = "";

	MyCharacter ch = null, ch2 = null, ch3 = null;
	Boolean typingStarted = false;

	ArrayList<MyCharacter> password = new ArrayList<MyCharacter>();
	// ArrayList<ArrayList<MyCharacter>> passwordList = new
	// ArrayList<ArrayList<MyCharacter>>();

	JTextField tfPattern, tfPassword, tfDwellTime, tfFlyingTime;
	JButton btnClear, btnEstimatePerson, btnSavePattern, btnClose;

	NormalizationHelper helper;
	MLRegression bestMethod;
	BasicNetwork network;
	File file;

	public EnterPassword(NormalizationHelper helper, MLRegression bestMethod) {
		this.resit_moji_metodou = false;
		this.helper = helper;
		this.bestMethod = bestMethod;

		startWindow();
	}

	public EnterPassword(BasicNetwork network, File file) {
		this.resit_moji_metodou = true;
		this.network = network;
		this.file = file;

		startWindow();
	}

	public void startWindow() {
		setTitle("Aplikace pro sber dat - Jan Kozlovsky");

		Container content = getContentPane();

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		content.setLayout(gridbag);

		c.fill = GridBagConstraints.NONE;
		c.weightx = 1.0;

		// Vzor hesla
		// -----------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Sem napište vzor hesla:"), c);

		// Pattern - vzor
		JPanel patternPanel = new JPanel();
		patternPanel.setLayout(new FlowLayout());
		tfPattern = new JTextField("", TEXTFIELD_SIZE - 10);
		tfPattern.setFocusable(true);
		tfPattern.setEditable(true);
		patternPanel.add(tfPattern);
		// Tlacitko pro ulozeni vzoru
		btnSavePattern = new JButton("Ulozit vzor");
		btnSavePattern.addActionListener(this);
		patternPanel.add(btnSavePattern);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(patternPanel, c);

		// Heslo
		// --------------------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Sem vepište heslo:"), c);

		JPanel inputPanel = new JPanel();
		inputPanel.setLayout(new FlowLayout());
		tfPassword = new JTextField("", TEXTFIELD_SIZE);
		tfPassword.setFocusable(true);
		tfPassword.setEditable(false);
		inputPanel.add(tfPassword);
		setActionListenersForTFPASSWORD();

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(inputPanel, c);

		// Doba
		// stisku-------------------------------------------------------------------------------------------
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Doba stisku [ms]"), c);

		JPanel outputPanel = new JPanel();
		outputPanel.setLayout(new FlowLayout());
		tfDwellTime = new JTextField("", TEXTFIELD_SIZE);
		tfDwellTime.setEditable(false);
		outputPanel.add(tfDwellTime);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(outputPanel, c);

		// Doba mezi
		// stisky------------------------------------------------------------------------------------------------
		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		content.add(new JLabel("Doba mezi stisky [ms]"), c);

		JPanel outputPanel2 = new JPanel();
		outputPanel2.setLayout(new FlowLayout());
		tfFlyingTime = new JTextField("", TEXTFIELD_SIZE);
		tfFlyingTime.setEditable(false);
		outputPanel2.add(tfFlyingTime);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(outputPanel2, c);
		// ----------------------------------------------------------------------------------------------------------------

		// Buttons
		JPanel buttonPanel = new JPanel();

		btnClear = new JButton("Vymazat heslo (je špatně)");
		btnEstimatePerson = new JButton("Vyhodnotit");
		btnClose = new JButton("Zavřít");

		btnClear.addActionListener(this);
		btnEstimatePerson.addActionListener(this);
		btnClose.addActionListener(this);

		buttonPanel.setLayout(new FlowLayout());
		buttonPanel.add(btnClear);
		buttonPanel.add(btnEstimatePerson);
		buttonPanel.add(btnClose);

		btnEstimatePerson.setEnabled(false);
		btnClear.setEnabled(false);

		content.add(buttonPanel, c);

		// adjust size and position
		pack();
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension d = toolkit.getScreenSize();
		setLocation((int) (d.width - this.getSize().getWidth()) / 2,
				(int) (d.height - this.getSize().getHeight()) / 2);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setResizable(false);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

	}

	public void setActionListenersForTFPASSWORD() {
		tfPassword.addKeyListener(new KeyListener() {

			public void keyTyped(KeyEvent arg0) {
				// TODO Auto-generated method stub

			}

			public void keyReleased(KeyEvent key) {
				if (typingStarted) {
					releasingTime = getActualMiliTime();

					MyCharacter mch = null;

					if (ch != null) {
						if (key.getKeyCode() == ch.getKeyCode()) {
							mch = ch;
							ch = null;
						}
					}
					if (ch2 != null) {
						if (key.getKeyCode() == ch2.getKeyCode()) {
							mch = ch2;
							ch2 = null;
						}
					}
					if (ch3 != null) {
						if (key.getKeyCode() == ch3.getKeyCode()) {
							mch = ch3;
							ch3 = null;
						}
					}

					dwellTime = releasingTime - mch.getPressingTime();
					mch.setDwellTime(dwellTime);

					if (dwellTimeString == "") {
						dwellTimeString = Double.toString(dwellTime);
					} else {
						dwellTimeString = dwellTimeString + ", "
								+ Double.toString(dwellTime);
					}
					tfDwellTime.setText(dwellTimeString);

					password.add(mch);

					if (tfPassword.getText().equals(tfPattern.getText())) {
						tfPassword.setForeground(Color.decode("#006400"));
						btnEstimatePerson.setEnabled(true);
					} else {
						tfPassword.setForeground(Color.RED);
						btnEstimatePerson.setEnabled(false);
					}
				}
			}

			public void keyPressed(KeyEvent key) {
				typingStarted = true;

				pressingTime = getActualMiliTime();
				if (releasingTime < 0) {
					flyingTime = 0;
				} else {
					flyingTime = pressingTime - releasingTime;
				}

				MyCharacter mch = new MyCharacter(pressingTime, flyingTime, key
						.getKeyCode(), key.getKeyChar());
				if (ch == null) {
					ch = mch;
				} else {
					if (ch2 == null) {
						ch2 = mch;
					} else {
						ch3 = mch;
					}
				}

				if (flyTimeString == "") {
					flyTimeString = Double.toString(flyingTime);
				} else {
					flyTimeString = flyTimeString + ", "
							+ Double.toString(flyingTime);
				}
				tfFlyingTime.setText(flyTimeString);
			}
		});
		;

	}

	public double getActualMiliTime() {
		return System.nanoTime() / TIME_CONST;
	}

	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == btnClear)
			clear();
		else if (e.getSource() == btnEstimatePerson) {
			if (resit_moji_metodou) {
				predictPersonMYMethod();
			} else {
				predictPersonENCOGMethod();
			}
		}

		else if (e.getSource() == btnSavePattern) {
			tfPassword.setEditable(true);
			tfPattern.setEditable(false);
			btnClear.setEnabled(true);
			btnSavePattern.setEnabled(false);
		} else if (e.getSource() == btnClose) {
			System.exit(0);
		}
	}

	protected void clear() {
		dwellTimeString = "";
		tfDwellTime.setText("");

		flyTimeString = "";
		tfFlyingTime.setText("");

		tfPassword.setText("");
		password.clear();

		tfPassword.requestFocus();

		btnEstimatePerson.setEnabled(false);

		releasingTime = -1;
	}

	protected void predictPersonMYMethod() {
		int numberOfInputFeatures = password.size() * 2;
		double[] pw = new double[numberOfInputFeatures];
		int counter = 0;
		for (MyCharacter mch : password) {
			pw[counter * 2] = mch.getFlyingTime();
			pw[counter * 2 + 1] = mch.getDwellTime();
			counter++;
		}
		EncogAnalyst analyst = new EncogAnalyst();
		analyst.load(file);

		NormalizeArray norm;
		counter = 0;
		double[] normalizedPw = new double[numberOfInputFeatures];
		for (AnalystField field : analyst.getScript().getNormalize()
				.getNormalizedFields()) {
			if (counter < numberOfInputFeatures) { // hrozi Index ouf of bound
													// exception
				double[] f = new double[3];
				f[0] = pw[counter];
				f[1] = field.getActualLow();
				f[2] = field.getActualHigh();

				norm = new NormalizeArray();
				norm.setNormalizedHigh(1);
				norm.setNormalizedLow(-1);

				double[] normalized = norm.process(f);
				System.out.print(normalized[0] + ",");
				
				normalizedPw[counter] = normalized[0];
			}
			counter++;
		}

		MLData input = new BasicMLData(normalizedPw);
		MLData output = network.compute(input);

		System.out.println("Prediction: ");
		System.out.println(output.getData(0) + ", " + output.getData(1));
		
		

		Encog.getInstance().shutdown();

	}

	protected void predictPersonENCOGMethod() {
		int numberOfInputFeatures = password.size() * 2;
		String[] line = new String[numberOfInputFeatures];
		int counter = 0;
		for (MyCharacter mch : password) {
			line[counter * 2] = Double.toString(mch.getFlyingTime());
			line[counter * 2 + 1] = Double.toString(mch.getDwellTime());
			counter++;
		}
		MLData input = helper.allocateInputVector(); // nastaveni velikosti
														// input vectoru

		StringBuilder result = new StringBuilder();
		// String correct = csv.get(numberOfInputFeatures);
		helper.normalizeInputVector(line, input.getData(), false);
		MLData output = bestMethod.compute(input);
		String personChosen = helper.denormalizeOutputVectorToString(output)[0];

		result.append(bestMethod.toString());
		result.append(" -> predicted: ");
		result.append(personChosen + "(values: " + output.getData()[0] + ", "
				+ output.getData()[1] + ", " + output.getData()[2] + ")");
		// result.append("(correct: ");
		// result.append(correct);
		// result.append(")");

		System.out.println(result.toString());

		// Delete data file ande shut down.
		// sourceFile.delete();
		Encog.getInstance().shutdown();

		// passwordList.add(password);
		password = null;
		password = new ArrayList<MyCharacter>();

		releasingTime = -1;

		dwellTimeString = "";
		tfDwellTime.setText("");

		flyTimeString = "";
		tfFlyingTime.setText("");

		tfPassword.setText("");

		tfPassword.requestFocus();
	}

}
