package com.kozloja3.biometric_authentication;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.naming.ldap.Rdn;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import org.encog.ConsoleStatusReportable;
import org.encog.Encog;
import org.encog.app.analyst.AnalystFileFormat;
import org.encog.app.analyst.EncogAnalyst;
import org.encog.app.analyst.csv.normalize.AnalystNormalizeCSV;
import org.encog.app.analyst.script.normalize.AnalystField;
import org.encog.app.analyst.wizard.AnalystWizard;
import org.encog.app.analyst.wizard.NormalizeRange;
import org.encog.engine.network.activation.ActivationLOG;
import org.encog.engine.network.activation.ActivationSigmoid;
import org.encog.engine.network.activation.ActivationTANH;
import org.encog.ml.MLRegression;
import org.encog.ml.data.MLData;
import org.encog.ml.data.MLDataPair;
import org.encog.ml.data.MLDataSet;
import org.encog.ml.data.versatile.NormalizationHelper;
import org.encog.ml.data.versatile.VersatileMLDataSet;
import org.encog.ml.data.versatile.columns.ColumnDefinition;
import org.encog.ml.data.versatile.columns.ColumnType;
import org.encog.ml.data.versatile.sources.CSVDataSource;
import org.encog.ml.data.versatile.sources.VersatileDataSource;
import org.encog.ml.factory.MLMethodFactory;
import org.encog.ml.model.EncogModel;
import org.encog.neural.networks.BasicNetwork;
import org.encog.neural.networks.layers.BasicLayer;
import org.encog.neural.networks.training.propagation.back.Backpropagation;
import org.encog.util.csv.CSVFormat;
import org.encog.util.csv.ReadCSV;
import org.encog.util.simple.EncogUtility;
import org.encog.util.simple.TrainingSetUtil;

import Function.ActivationRectifiedLinear;
import GUI.Drawer;
import GUI.EnterPassword;

public class App extends JFrame implements ActionListener {
	private static final long serialVersionUID = 1L;

	public static enum ActivationFunctionEnum {
		SIG, RELU, TANH, LOG
	}

	// NASTAVENI NN SĂŤTĂŤ-----------------------------------------------

	// jestlize je false, pak se vyhodnocuje heslo velikonocnizajic
	public static Boolean optimalizace = true;
	private static int numberOfHiddenLayers = 8;
	private static int numberOfNeuronsInOneHiddenLayer = 30;
	private static ActivationFunctionEnum activationFunction = ActivationFunctionEnum.LOG; // TANH
																							// RELU
																							// LOG
																							// SIG
	private static Boolean hasBias = true;

	public static final Boolean resit_moji_metodou = true;
	public static final Boolean add_false_user = true;
	private static final int pocet_uzivatelu = 3;

	private static double TRAINING_ERROR = 0.0005;

	// PROMENNE--------------------------------------------------------
	private static String optimalizace_H, optimalizace_A, optimalizace_M,
			optimalizaceInputForNorm, optimalizaceOutputOfNorm,
			optimalizace_Statistics_File, velikonocnizajic_H,
			velikonocnizajic_A, velikonocnizajic_M,
			velikonocnizajicInputForNorm, velikonocnizajicOutputOfNorm,
			velikonocnizajic_Statistics_File, optimalizace_H_testing,
			optimalizace_A_testing, optimalizace_M_testing,
			optimalizaceInputForNormTesting, optimalizaceOutputOfNormTesting,
			velikonocnizajic_H_testing, velikonocnizajic_A_testing,
			velikonocnizajic_M_testing, velikonocnizajicInputForNormTesting,
			velikonocnizajicOutputOfNormTesting, optimalizace_testing_false,
			velikonocnizajic_testing_false,
			velikonocnizajic_testing_target_false_file,
			optimalizace_testing_target_false_file;

	private static File sourceFile, targetFile, statisticFile,
			testingSourceFile, testingTargetFile, testing_false_file,
			testing_false_target_file;

	static int numberOfInputFeatures;
	static DataWorker dataWorker = new DataWorker(resit_moji_metodou);
	private static NormalizationHelper helper;
	private static MLRegression bestMethod;
	private static BasicNetwork network;

	private static String FM = "%.3f";
	private static int count_too_far_but_correct = 0,
			count_false_but_accepted = 0;

	private static List<Integer[]> predicted = new ArrayList<Integer[]>();

	private static double threshold = 0.05; // In percents
	private static double thr; // Counted threshold in pixels
	private static double threshold_distance;

	static JTextField tfNumberOfNeuronsInHiddenLayer, tfNumberOfHiddenLayers;
	public static final int SIZE = 4, TEXTFIELD_SIZE = 10;
	static JButton btnShowResults;
	static JScrollPane scrollPane;
	static JTextArea textArea;
	private final static String newline = "\n";
	static JButton btnProcess;
	static JRadioButton rdbtnOptimalizace, rdbtnVelikonocnizajic, rdbtnTANH, rdbtnSIG, rdbtnRELU, rdbtnLOG;

	public static void main(String[] args) {
		JFrame frame = new App();
		frame.setVisible(true);
	}

	public App() {
		assignVariables();

		// GUI
		setTitle("Biometricka autentizace - Jan Kozlovsky");

		Container content = getContentPane();

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		content.setLayout(gridbag);

		c.fill = GridBagConstraints.NONE;
		c.weightx = 1.0;

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Vyber hesla k vyhodnoceni:"), c);

		JPanel pswPanel = new JPanel();
		pswPanel.setLayout(new FlowLayout());

		ButtonGroup bGPassword = new ButtonGroup();

		rdbtnOptimalizace = new JRadioButton("Optimalizace");
		bGPassword.add(rdbtnOptimalizace);
		rdbtnOptimalizace.setSelected(true);
		pswPanel.add(rdbtnOptimalizace);

		rdbtnVelikonocnizajic = new JRadioButton(
				"Velikonocnizajic");
		bGPassword.add(rdbtnVelikonocnizajic);
		pswPanel.add(rdbtnVelikonocnizajic);

		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.WEST;
		content.add(pswPanel, c);

		// Heslo
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Vyber aktivacni funkce:"), c);

		JPanel activationFuncPanel = new JPanel();
		activationFuncPanel.setLayout(new FlowLayout());

		ButtonGroup bGActivationF = new ButtonGroup();
		rdbtnTANH = new JRadioButton("TanH");
		bGActivationF.add(rdbtnTANH);
		activationFuncPanel.add(rdbtnTANH);
		rdbtnTANH.setSelected(true);

		rdbtnSIG = new JRadioButton("Sig");
		bGActivationF.add(rdbtnSIG);
		activationFuncPanel.add(rdbtnSIG);

		rdbtnRELU = new JRadioButton("ReLU");
		bGActivationF.add(rdbtnRELU);
		activationFuncPanel.add(rdbtnRELU);

		rdbtnLOG = new JRadioButton("Log");
		bGActivationF.add(rdbtnLOG);
		activationFuncPanel.add(rdbtnLOG);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(activationFuncPanel, c);

		// Pocet skrytych vrstev
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Pocet skrytych vrstev: "), c);

		JPanel hiddenLayersPanel = new JPanel();
		hiddenLayersPanel.setLayout(new FlowLayout());
		tfNumberOfHiddenLayers = new JTextField("2", TEXTFIELD_SIZE);
		tfNumberOfHiddenLayers.setEditable(true);
		hiddenLayersPanel.add(tfNumberOfHiddenLayers);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(hiddenLayersPanel, c);

		// Pocet skrytych vrstev
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Pocet neuronu v jedne skryte vrstve: "), c);

		JPanel numOfNeuronsPanel = new JPanel();
		numOfNeuronsPanel.setLayout(new FlowLayout());
		tfNumberOfNeuronsInHiddenLayer = new JTextField("10", TEXTFIELD_SIZE);
		tfNumberOfNeuronsInHiddenLayer.setEditable(true);
		numOfNeuronsPanel.add(tfNumberOfNeuronsInHiddenLayer);

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(numOfNeuronsPanel, c);

		// Buttons

		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Volba dalsiho kroku: "), c);

		JPanel nextStepPanel = new JPanel();
		nextStepPanel.setLayout(new FlowLayout());

		btnProcess = new JButton("Vyhodnotit");
		nextStepPanel.add(btnProcess);
		btnProcess.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				process();
			}
		});

		btnShowResults = new JButton("Ukazat na grafu");
		btnShowResults.setEnabled(false);
		nextStepPanel.add(btnShowResults);
		btnShowResults.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				showResults();
			}
		});

		JButton btnClose = new JButton("Zavrit");
		nextStepPanel.add(btnClose);
		btnClose.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				// enterPassword();
				System.exit(0);
			}
		});
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(nextStepPanel, c);

		// TF
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.NORTHWEST;
		content.add(new JLabel("Vystup: "), c);

		JPanel outputPanel = new JPanel();
		outputPanel.setLayout(new FlowLayout());

		textArea = new JTextArea(15, 60);
		scrollPane = new JScrollPane(textArea); 
		textArea.setEditable(false);
		outputPanel.add(scrollPane);
		
		c.gridwidth = GridBagConstraints.REMAINDER; // end row
		c.anchor = GridBagConstraints.WEST;
		content.add(outputPanel, c);

		this.pack();
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension d = toolkit.getScreenSize();
		setLocation((int) (d.width - this.getSize().getWidth()) / 2,
				(int) (d.height - this.getSize().getHeight()) / 2);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setResizable(false);

	}

	private static void process() {
		if(rdbtnVelikonocnizajic.isSelected()){
			optimalizace = false;
		}
		if(rdbtnVelikonocnizajic.isSelected()){
			optimalizace = true;
		}
		if(rdbtnLOG.isSelected()){
			activationFunction = ActivationFunctionEnum.LOG;
		}
		if(rdbtnSIG.isSelected()){
			activationFunction = ActivationFunctionEnum.SIG;
		}
		if(rdbtnTANH.isSelected()){
			activationFunction = ActivationFunctionEnum.TANH;
		}
		if(rdbtnRELU.isSelected()){
			activationFunction = ActivationFunctionEnum.RELU;
		}
		numberOfHiddenLayers = Integer.parseInt(tfNumberOfHiddenLayers.getText());
		numberOfNeuronsInOneHiddenLayer = Integer.parseInt(tfNumberOfNeuronsInHiddenLayer.getText());
			
		if (optimalizace) {
			// ostra data
			numberOfInputFeatures = dataWorker
					.gatherDataFromUsersAndGenerateSourceCSVFile(
							optimalizace_H, optimalizace_A, optimalizace_M,
							optimalizaceInputForNorm);

			sourceFile = new File(optimalizaceInputForNorm);
			targetFile = new File(optimalizaceOutputOfNorm);
			statisticFile = new File(optimalizace_Statistics_File);

			// testovaci data
			dataWorker.gatherDataFromUsersAndGenerateSourceCSVFile(
					optimalizace_H_testing, optimalizace_A_testing,
					optimalizace_M_testing, optimalizaceInputForNormTesting);

			testingSourceFile = new File(optimalizaceInputForNormTesting);
			testingTargetFile = new File(optimalizaceOutputOfNormTesting);

			testing_false_file = new File(optimalizace_testing_false);
			testing_false_target_file = new File(
					optimalizace_testing_target_false_file);

		} else { // velikonocnizajic
			// ostra data
			numberOfInputFeatures = dataWorker
					.gatherDataFromUsersAndGenerateSourceCSVFile(
							velikonocnizajic_H, velikonocnizajic_A,
							velikonocnizajic_M, velikonocnizajicInputForNorm);

			sourceFile = new File(velikonocnizajicInputForNorm);
			targetFile = new File(velikonocnizajicOutputOfNorm);
			statisticFile = new File(velikonocnizajic_Statistics_File);

			// testovaci data
			dataWorker.gatherDataFromUsersAndGenerateSourceCSVFile(
					velikonocnizajic_H_testing, velikonocnizajic_A_testing,
					velikonocnizajic_M_testing,
					velikonocnizajicInputForNormTesting);

			testingSourceFile = new File(velikonocnizajicInputForNormTesting);
			testingTargetFile = new File(velikonocnizajicOutputOfNormTesting);

			testing_false_file = new File(velikonocnizajic_testing_false);
			testing_false_target_file = new File(
					velikonocnizajic_testing_target_false_file);
		}

		if (resit_moji_metodou) {
			myMethod();
			btnShowResults.setEnabled(true);
		} else {
			automaticMethod();
		}
	}

	private void showResults() {
		Drawer mainPanel = new Drawer(predicted, thr);
		JFrame frame = new JFrame("DrawGraph");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().add(mainPanel);
		frame.pack();
		frame.setLocationByPlatform(true);
		frame.setVisible(true);
	}

	private void enterPassword() {

		if (resit_moji_metodou) {
			JFrame passwordEnterer = new EnterPassword(network, statisticFile);
			passwordEnterer.setVisible(true);

		} else {
			JFrame passwordEnterer = new EnterPassword(helper, bestMethod);
			passwordEnterer.setVisible(true);
		}

	}

	private static void myMethod() {
		// Normalizace trenovacich dat
		EncogAnalyst analyst = new EncogAnalyst();
		AnalystWizard wizard = new AnalystWizard(analyst);
		wizard.setRange(NormalizeRange.NegOne2One); // Zero2One NegOne2One
		wizard.wizard(sourceFile, true, AnalystFileFormat.DECPNT_COMMA);
		dumpFieldInfo(analyst);
		AnalystNormalizeCSV norm = new AnalystNormalizeCSV();
		norm.analyze(sourceFile, true, CSVFormat.ENGLISH, analyst);
		// norm.setOutputFormat(CSVFormat .ENGLISH);
		norm.setProduceOutputHeaders(true);
		norm.normalize(targetFile);

		analyst.save(statisticFile);

		// normalizace testovacich dat
		analyst.load(statisticFile);
		// wizard = new AnalystWizard(analyst);
		// wizard.setRange(NormalizeRange.NegOne2One); //Zero2One
		// wizard.wizard(testingSourceFile, true,
		// AnalystFileFormat.DECPNT_COMMA);
		dumpFieldInfo(analyst);
		norm = new AnalystNormalizeCSV();
		norm.analyze(testingSourceFile, true, CSVFormat.ENGLISH, analyst);
		// norm.setProduceOutputHeaders(true);
		norm.normalize(testingTargetFile);

		// normalizace dat uzivatele false
		if (add_false_user) {
			analyst.load(statisticFile);
			// wizard = new AnalystWizard(analyst);
			// wizard.setRange(NormalizeRange.NegOne2One); //Zero2One
			// wizard.wizard(testingSourceFile, true,
			// AnalystFileFormat.DECPNT_COMMA);
			dumpFieldInfo(analyst);
			norm = new AnalystNormalizeCSV();
			norm.analyze(testing_false_file, true, CSVFormat.ENGLISH, analyst);
			// norm.setProduceOutputHeaders(true);
			norm.normalize(testing_false_target_file); // write the normalized
														// data of false users
														// to temp. file

			// Adding data from testing_false_target_file (temp. file) to the
			// end of a testingTargetFile.
			dataWorker.mergeTwoCSVFiles(testingTargetFile.getPath(),
					testing_false_target_file.getPath());

		}

		Encog.getInstance().shutdown();

		// AnalystScript script = analyst.getScript();
		// analyst.load(new File(target_Statistics_File));
		// AnalystNormalize norm2 = new AnalystNormalize(script);

		// setting values to MLDataSet
		MLDataSet trainingSet, testingSet;
		if (optimalizace) {
			trainingSet = TrainingSetUtil.loadCSVTOMemory(CSVFormat.ENGLISH,
					optimalizaceOutputOfNorm, true, numberOfInputFeatures,
					pocet_uzivatelu - 1);
			testingSet = TrainingSetUtil.loadCSVTOMemory(CSVFormat.ENGLISH,
					optimalizaceOutputOfNormTesting, true,
					numberOfInputFeatures, pocet_uzivatelu - 1);
		} else {
			trainingSet = TrainingSetUtil.loadCSVTOMemory(CSVFormat.ENGLISH,
					velikonocnizajicOutputOfNorm, true, numberOfInputFeatures,
					pocet_uzivatelu - 1);
			testingSet = TrainingSetUtil.loadCSVTOMemory(CSVFormat.ENGLISH,
					velikonocnizajicOutputOfNormTesting, true,
					numberOfInputFeatures, pocet_uzivatelu - 1);
		}

		// Design NN
		network = new BasicNetwork();
		network.addLayer(new BasicLayer(null, hasBias, numberOfInputFeatures));
		switch (activationFunction) {
		case SIG:
			for (int i = 0; i < numberOfHiddenLayers; i++) {
				network.addLayer(new BasicLayer(new ActivationSigmoid(),
						hasBias, numberOfNeuronsInOneHiddenLayer));
			}
			network.addLayer(new BasicLayer(new ActivationSigmoid(), false, 2));

			threshold_distance = threshold * 1;
			break;

		case LOG:
			for (int i = 0; i < numberOfHiddenLayers; i++) {
				network.addLayer(new BasicLayer(new ActivationLOG(), hasBias,
						numberOfNeuronsInOneHiddenLayer));
			}
			network.addLayer(new BasicLayer(new ActivationLOG(), false, 2));

			threshold_distance = threshold * 2;
			break;

		case TANH:
			for (int i = 0; i < numberOfHiddenLayers; i++) {
				network.addLayer(new BasicLayer(new ActivationTANH(), hasBias,
						numberOfNeuronsInOneHiddenLayer));
			}
			network.addLayer(new BasicLayer(new ActivationTANH(), false, 2));

			threshold_distance = threshold * 2;
			break;

		case RELU:
			for (int i = 0; i < numberOfHiddenLayers; i++) {
				network.addLayer(new BasicLayer(
						new ActivationRectifiedLinear(), hasBias,
						numberOfNeuronsInOneHiddenLayer));
			}
			network.addLayer(new BasicLayer(new ActivationRectifiedLinear(),
					false, 2));

			threshold_distance = threshold * 1;
			break;
		}
		network.getStructure().finalizeStructure();
		network.reset();

		// train the neural network
		final Backpropagation train = new Backpropagation(network, trainingSet);

		int epoch = 1;
		do {
			train.iteration();
			String out = "Epoch #" + epoch + " Error : "
					+ train.getError();
			System.out.println(out);
			textArea.append(out + newline);
			epoch++;
		} while (train.getError() > TRAINING_ERROR);
		System.out.println("Total epoches: " + epoch);
		textArea.append("Total epoches: " + epoch + newline);
		train.finishTraining();

		// test the neural network on training data
		System.out.println("Neural Network Results on training data: ");
		textArea.append("Neural Network Results on training data: " + newline);
		int iterator = 0;
		for (MLDataPair pair : trainingSet) {
			iterator++;
			final MLData output = network.compute(pair.getInput());
			String out = "Input: " + iterator + ". Actual = "
					+ String.format(FM, output.getData(0)) + "; "
					+ String.format(FM, output.getData(1)) + "; Ideal = "
					+ String.format(FM, pair.getIdeal().getData(0)) + "; "
					+ String.format(FM, pair.getIdeal().getData(1));
			System.out.println(out);
			textArea.append(out + newline);
		}

		// test the neural network on new data
		System.out.println("Neural Network Results on new data: ");
		textArea.append("Neural Network Results on new data: " + newline);
		iterator = 0;
		double meanError = 0, actualRelativeError = 0, globalRelativeError = 0, meanRelativeError = 0;
		double userAIdeal0 = 0, userAIdeal1 = 0, userBIdeal0 = 0, userBIdeal1 = 0, userCIdeal0 = 0, userCIdeal1 = 0;
		int numOfCasesOverTenPercent = 0;
		for (MLDataPair pair : testingSet) {
			double distanceFromIdeal = 0;
			iterator++;
			final MLData output = network.compute(pair.getInput());
			double idealData0 = pair.getIdeal().getData(0);
			double idealData1 = pair.getIdeal().getData(1);
			double outputData0 = output.getData(0);
			double outputData1 = output.getData(1);

			// ZĂ­skĂˇnĂ­ vzorovĂ˝ch vĂ˝stupĹŻ pro 3 vzorovĂ© uĹľivatele, je moĹľno vzĂ­t
			// z prvnĂ­ch 3 zĂˇznamĹŻ.
			switch (iterator) {
			case 1:
				userAIdeal0 = idealData0;
				userAIdeal1 = idealData1;
				break;
			case 2:
				userBIdeal0 = idealData0;
				userBIdeal1 = idealData1;
				break;
			case 3:
				userCIdeal0 = idealData0;
				userCIdeal1 = idealData1;
				break;
			}

			distanceFromIdeal = 0;

			if (idealData0 == 0 && idealData1 == 0) {
				// False User
				double distanceFromUserA = Math
						.sqrt((outputData0 - userAIdeal0)
								* (outputData0 - userAIdeal0)
								+ (outputData1 - userAIdeal1)
								* (outputData1 - userAIdeal1));
				double distanceFromUserB = Math
						.sqrt((outputData0 - userBIdeal0)
								* (outputData0 - userBIdeal0)
								+ (outputData1 - userBIdeal1)
								* (outputData1 - userBIdeal1));
				double distanceFromUserC = Math
						.sqrt((outputData0 - userCIdeal0)
								* (outputData0 - userCIdeal0)
								+ (outputData1 - userCIdeal1)
								* (outputData1 - userCIdeal1));

				if (distanceFromUserA < threshold_distance
						|| distanceFromUserB < threshold_distance
						|| distanceFromUserC < threshold_distance) {
					count_false_but_accepted++;
				}
			} else {
				// Normal user
				distanceFromIdeal = Math.sqrt((outputData0 - idealData0)
						* (outputData0 - idealData0)
						+ (outputData1 - idealData1)
						* (outputData1 - idealData1));

				if (distanceFromIdeal > threshold_distance) {
					count_too_far_but_correct++;
				}
			}

			if (idealData0 == 0 || idealData1 == 0) {
				// http://math.stackexchange.com/questions/677852/how-to-calculate-relative-error-when-true-value-is-zero

			} else {
				actualRelativeError = (((output.getData(0) - pair.getIdeal()
						.getData(0)) / pair.getIdeal().getData(0)) + ((output
						.getData(1) - pair.getIdeal().getData(1)) / pair
						.getIdeal().getData(1))) / 2;
			}
			globalRelativeError = globalRelativeError + actualRelativeError;
			meanRelativeError = globalRelativeError / iterator;

			if (Math.abs(actualRelativeError) > 0.1) {
				String out = "Input: " + iterator + ". Actual = "
						+ String.format(FM, output.getData(0)) + "; "
						+ String.format(FM, output.getData(1)) + "; Ideal = "
						+ String.format(FM, pair.getIdeal().getData(0)) + "; "
						+ String.format(FM, pair.getIdeal().getData(1))
						+ " |||| Actual Rel. Error: "
						+ String.format(FM, actualRelativeError) + " !!!";
				System.out.println(out);
				textArea.append(out + newline);
				
				numOfCasesOverTenPercent++;
			} else {
				String out = "Input: " + iterator + ". Actual = "
						+ String.format(FM, output.getData(0)) + "; "
						+ String.format(FM, output.getData(1)) + "; Ideal = "
						+ String.format(FM, pair.getIdeal().getData(0)) + "; "
						+ String.format(FM, pair.getIdeal().getData(1))
						+ " |||| Actual Rel. Error: "
						+ String.format(FM, actualRelativeError);
				System.out.println(out);
				textArea.append(out + newline);
			}

			// NaplnÄ›nĂ­ hodnot pro graf

			// Naplneni nejprve vzorovych hodnot pro 3 uzivatele
			if (iterator < 4) {
				Integer[] dd = new Integer[3];
				dd[0] = getCoord(idealData0);
				dd[1] = getCoord(idealData1);
				dd[2] = 0;

				if (dd[0] == userAIdeal0 && dd[1] == userAIdeal1) {
					dd[2] = 1; // UserA
				}
				if (dd[0] == userBIdeal0 && dd[1] == userBIdeal1) {
					dd[2] = 2; // UserB
				}
				if (dd[0] == userCIdeal0 && dd[1] == userCIdeal1) {
					dd[2] = 3; // UserC
				}
				predicted.add(dd); // pridani vrcholu trojuhelnika, idealnich
									// vystupu
			}
			// naplneni do predikovanych vystupu
			Integer[] dd2 = new Integer[3];
			dd2[0] = getCoord(outputData0);
			dd2[1] = getCoord(outputData1);

			if (idealData0 == 0 && idealData1 == 0) {
				dd2[2] = 4; // FalseUser
			}
			if (idealData0 == userAIdeal0 && idealData1 == userAIdeal1) {
				dd2[2] = 1; // UserA
			}
			if (idealData0 == userBIdeal0 && idealData1 == userBIdeal1) {
				dd2[2] = 2; // UserB
			}
			if (idealData0 == userCIdeal0 && idealData1 == userCIdeal1) {
				dd2[2] = 3; // UserC
			}
			predicted.add(dd2);
		}
		Encog.getInstance().shutdown();

		String out1 = "Pocet chybne akceptovanych cizich uzivatelu: "
				+ count_false_but_accepted;
		System.out.println(out1);
		textArea.append(out1 + newline);
		
		String out2 = "Pocet chybne odmitnutych spravnych uzivatelu: "
				+ count_too_far_but_correct;
		System.out.println(out2);
		textArea.append(out2 + newline);
		
		String out3 = "Celkovy pocet vzorku: " + iterator;
		System.out.println(out3);
		textArea.append(out3 + newline);
	}

	private static Integer getCoord(double d) {
		int graphSize = 600;
		thr = threshold * graphSize;

		int result = 0;

		switch (activationFunction) {
		case RELU:
			result = (int) (d * graphSize);
			break;

		case SIG:
			result = (int) (d * graphSize);
			break;

		case TANH:
			result = (int) ((d + 1) * graphSize / 2);
			break;

		case LOG:
			result = (int) ((d + 1) * graphSize / 2);
			break;
		}
		return result;
	}

	// =======================================

	/**
	 * This method evaluates data automatically and also automatically chooses
	 * the neural network structure. It is not possible to control the neural
	 * network architecture.
	 */
	private static void automaticMethod() {
		VersatileDataSource source = new CSVDataSource(sourceFile, false,
				CSVFormat.ENGLISH);
		VersatileMLDataSet data = new VersatileMLDataSet(source);

		try {

			for (int i = 0; i < numberOfInputFeatures / 2; i++) {
				StringBuilder line = new StringBuilder();
				line.append("FT");
				line.append(i);
				int index = i * 2;
				System.out.println(line.toString() + ", index: " + index);
				data.defineSourceColumn(line.toString(), index,
						ColumnType.continuous);

				StringBuilder line2 = new StringBuilder();
				line2.append("DT");
				line2.append(i);
				int index2 = i * 2 + 1;
				System.out.println(line2.toString() + ", index: " + index2);
				data.defineSourceColumn(line2.toString(), index2,
						ColumnType.continuous);
			}

			// Define the column that we are trying to predict.
			int index3 = numberOfInputFeatures;
			ColumnDefinition outputColumn = data.defineSourceColumn("User",
					index3, ColumnType.nominal);
			System.out.println("User, index: " + index3);

			// Analyze the data, determine the min/max/mean/sd of every column.
			data.analyze();

			// Map the prediction column to the output of the model, and all
			// other columns to the input.
			data.defineSingleOutputOthersInput(outputColumn);

			// Create feedforward neural network as the model type.
			// MLMethodFactory.TYPE_FEEDFORWARD.
			// You could also other model types, such as:
			// MLMethodFactory.SVM: Support Vector Machine (SVM)
			// MLMethodFactory.TYPE_RBFNETWORK: RBF Neural Network
			// MLMethodFactor.TYPE_NEAT: NEAT Neural Network
			// MLMethodFactor.TYPE_PNN: Probabilistic Neural Network
			EncogModel model = new EncogModel(data);

			model.selectMethod(data, MLMethodFactory.TYPE_FEEDFORWARD);

			// Send any output to the console.
			model.setReport(new ConsoleStatusReportable());

			// Now normalize the data. Encog will automatically determine the
			// correct normalization
			// type based on the model you chose in the last step.
			data.normalize();

			// Individualizace normalizace - zeby to slo?
			// http://stackoverflow.com/questions/26508890/how-to-set-normalization-range-in-encog

			// Hold back some data for a final validation.
			// Shuffle the data into a random ordering.
			// Use a seed of 1001 so that we always use the same holdback and
			// will get more consistent results.
			model.holdBackValidation(0.3, true, 1001);

			// Choose whatever is the default training type for this model.
			model.selectTrainingType(data);

			// Use a 5-fold cross-validated train. Return the best method found.
			bestMethod = (MLRegression) model.crossvalidate(5, true);

			// Display the training and validation errors.
			System.out.println("Training error: "
					+ EncogUtility.calculateRegressionError(bestMethod,
							model.getTrainingDataset()));
			System.out.println("Validation error: "
					+ EncogUtility.calculateRegressionError(bestMethod,
							model.getValidationDataset()));

			// Display our normalization parameters.
			helper = data.getNormHelper();
			System.out.println(helper.toString());

			// Display the final model.
			System.out.println("Final model: " + bestMethod);

			// Loop over the entire, original, dataset and feed it through the
			// model.
			// This also shows how you would process new data, that was not part
			// of your
			// training set. You do not need to retrain, simply use the
			// NormalizationHelper
			// class. After you train, you can save the NormalizationHelper to
			// later
			// normalize and denormalize your data.
			ReadCSV csv = new ReadCSV(sourceFile, false,
					CSVFormat.DECIMAL_POINT);
			String[] line = new String[numberOfInputFeatures];
			MLData input = helper.allocateInputVector();

			while (csv.next()) {
				StringBuilder result = new StringBuilder();
				for (int i = 0; i < numberOfInputFeatures; i++) {
					line[i] = csv.get(i);
				}
				String correct = csv.get(numberOfInputFeatures);
				helper.normalizeInputVector(line, input.getData(), false);
				MLData output = bestMethod.compute(input);
				String personChosen = helper
						.denormalizeOutputVectorToString(output)[0];

				result.append(Arrays.toString(line));
				result.append(" -> predicted: ");
				result.append(personChosen + "(values: " + output.getData()[0]
						+ ")");
				result.append("(correct: ");
				result.append(correct);
				result.append(")");

				// System.out.println(result.toString());

				// vypsat jen chybne vysledky
				if (!personChosen.equals(correct)) {
					System.out.println("chybne zarazeno: ");
					System.out.println(result.toString());
				}

			}

			// Delete data file and shut down.
			// sourceFile.delete();
			Encog.getInstance().shutdown();

		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	private static void dumpFieldInfo(EncogAnalyst analyst) {
		System.out.println("Fields found in file:");
		textArea.append("Fields found in file:" + newline);

		int counter = 0;

		for (AnalystField field : analyst.getScript().getNormalize()
				.getNormalizedFields()) {

			// normalizace vystupnich hodnot na interval 0;1 bez ohledu na to,
			// zyda vstupy jsou normalizovĂˇny na -1;1.
			// normalizace vystupu na 0;1 je potĹ™eba kvuli sigmoidÄ› i ReLU
			if (counter >= numberOfInputFeatures) {
				if (activationFunction == ActivationFunctionEnum.SIG
						|| activationFunction == ActivationFunctionEnum.RELU) {
					field.setNormalizedHigh(1);
					field.setNormalizedLow(0);
				}
			}

			StringBuilder line = new StringBuilder();
			line.append(field.getName());
			line.append(",action=");
			line.append(field.getAction());
			line.append(",min=");
			line.append(field.getActualLow());
			line.append(",max=");
			line.append(field.getActualHigh());
			System.out.println(line.toString());
			textArea.append(line.toString() + newline);

			counter++;
		}
	}

	private static void assignVariables() {

		// OPTIMALIZACE
		optimalizace_H = ".\\CSV_sources\\optimalizace\\j.csv";
		optimalizace_A = ".\\CSV_sources\\optimalizace\\a.csv";
		optimalizace_M = ".\\CSV_sources\\optimalizace\\m.csv";

		optimalizace_H_testing = ".\\CSV_sources\\optimalizace\\testing\\j.csv";
		optimalizace_A_testing = ".\\CSV_sources\\optimalizace\\testing\\a.csv";
		optimalizace_M_testing = ".\\CSV_sources\\optimalizace\\testing\\m.csv";

		optimalizaceInputForNorm = ".\\CSV_sources\\optimalizace\\analysis\\InputForNormalization.csv";
		optimalizaceOutputOfNorm = ".\\CSV_sources\\optimalizace\\analysis\\OutputOfNormalization.csv";
		optimalizace_Statistics_File = ".\\CSV_sources\\optimalizace\\analysis\\stats.ega";

		optimalizaceInputForNormTesting = ".\\CSV_sources\\optimalizace\\testing\\analysis\\InputForNormalization.csv";
		optimalizaceOutputOfNormTesting = ".\\CSV_sources\\optimalizace\\testing\\analysis\\OutputOfNormalization.csv";

		optimalizace_testing_false = ".\\CSV_sources\\optimalizace\\testing\\false.csv";
		optimalizace_testing_target_false_file = ".\\CSV_sources\\optimalizace\\testing\\analysis\\Temp\\false.csv";

		// VELIKONOCNNIZAJIC
		velikonocnizajic_H = ".\\CSV_sources\\velikonocnizajic\\j.csv";
		velikonocnizajic_A = ".\\CSV_sources\\velikonocnizajic\\a.csv";
		velikonocnizajic_M = ".\\CSV_sources\\velikonocnizajic\\m.csv";

		velikonocnizajic_H_testing = ".\\CSV_sources\\velikonocnizajic\\testing\\j.csv";
		velikonocnizajic_A_testing = ".\\CSV_sources\\velikonocnizajic\\testing\\a.csv";
		velikonocnizajic_M_testing = ".\\CSV_sources\\velikonocnizajic\\testing\\m.csv";

		velikonocnizajicInputForNorm = ".\\CSV_sources\\velikonocnizajic\\analysis\\InputForNormalization.csv";
		velikonocnizajicOutputOfNorm = ".\\CSV_sources\\velikonocnizajic\\analysis\\OutputOfNormalization.csv";
		velikonocnizajic_Statistics_File = ".\\CSV_sources\\velikonocnizajic\\analysis\\stats.ega";

		velikonocnizajicInputForNormTesting = ".\\CSV_sources\\velikonocnizajic\\testing\\analysis\\InputForNormalization.csv";
		velikonocnizajicOutputOfNormTesting = ".\\CSV_sources\\velikonocnizajic\\testing\\analysis\\OutputOfNormalization.csv";

		velikonocnizajic_testing_false = ".\\CSV_sources\\velikonocnizajic\\testing\\false.csv";
		velikonocnizajic_testing_target_false_file = ".\\CSV_sources\\velikonocnizajic\\testing\\analysis\\Temp\\false.csv";
	}

	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub

	}

}
