package com.kozloja3.biometric_authentication;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;

public class DataWorker {
	
	private Boolean resit_moji_metodou;
	
	ArrayList<ArrayList<Double>> pwListHonza, pwListAnicka, pwListMarketka, pwListGlobal;
	static final String userH = "Honza", userA = "Anicka", userM = "Marketka";
	
	public DataWorker(Boolean resit_moji_metodou){
		this.resit_moji_metodou = resit_moji_metodou;
	}
	
	public int gatherDataFromUsersAndGenerateSourceCSVFile(
			String inputH, String inputA, String inputM, String target) {			
		pwListHonza = readCSV(inputH, userH);
		pwListAnicka = readCSV(inputA, userA);
		pwListMarketka = readCSV(inputM, userM);
		
		// maximum number of samples and number of characters in
		// password----------------------------------------------------------------
		int sizeHonza = pwListHonza.size();
		int sizeMarketka = pwListMarketka.size();
		int sizeAnicka = pwListAnicka.size();

		int maxNumOfSamples = 0; // number of passwords which everybody has. 
		if (sizeHonza >= sizeAnicka) {
			maxNumOfSamples = sizeAnicka;
		} else {
			maxNumOfSamples = sizeHonza;
		}
		if (sizeMarketka <= maxNumOfSamples) {
			maxNumOfSamples = sizeMarketka;
		}
		System.out.println("Max. number of samples: " + maxNumOfSamples);
		ArrayList<Double> p = pwListHonza.get(1);
		int numberOfInputFeatures = p.size();
		System.out.println("Number of input features: "
				+ numberOfInputFeatures);
		// --------------------------------------------------------------------------------------------------------------------------------

		pwListGlobal = new ArrayList<ArrayList<Double>>();

		for (int i = 0; i < maxNumOfSamples; i++) {
			ArrayList<Double> pwHonza = pwListHonza.get(i);
			ArrayList<Double> pwAnicka = pwListAnicka.get(i);
			ArrayList<Double> pwMarketka = pwListMarketka.get(i);

			pwListGlobal.add(pwHonza);
			pwListGlobal.add(pwAnicka);
			pwListGlobal.add(pwMarketka);
		}

		// zjisteni kolik passwords mi jeste zbylo u kazdeho a podle toho je
		// doplnim nakonec----------------------------
		int restOfPasswordsHonza = sizeHonza - maxNumOfSamples;
		int restOfPasswordsMarketka = sizeMarketka - maxNumOfSamples;
		int restOfPasswordsAnicka = sizeAnicka - maxNumOfSamples;

		if (restOfPasswordsHonza > 0) {
			for (int i = 0; i < restOfPasswordsHonza; i++) {
				pwListGlobal.add(pwListHonza.get(maxNumOfSamples + i));
			}
		}
		if (restOfPasswordsAnicka > 0) {
			for (int i = 0; i < restOfPasswordsAnicka; i++) {
				pwListGlobal.add(pwListAnicka.get(maxNumOfSamples + i));
			}
		}
		if (restOfPasswordsMarketka > 0) {
			for (int i = 0; i < restOfPasswordsMarketka; i++) {
				pwListGlobal.add(pwListMarketka.get(maxNumOfSamples + i));
			}
		}
		// -------------------------------------------------------------------------------------------------------------

		generateCsvFile(pwListGlobal, target);	
		return numberOfInputFeatures;
	}
	
	/**
	 * The method that will add the content of source file to the end of a target file. There are already data in target file. This method will add new data to the end.
	 * @param targetFile
	 * @param sourceFile
	 */
	public void mergeTwoCSVFiles(String targetFile, String sourceFile)  {
		
		//read data from the first one
		BufferedReader br = null;
		String line = "\n";
		String csvSplitBy = ",";
		
		

		System.out.println("Source: " + sourceFile);
		try {
			FileWriter writer = new FileWriter(targetFile, true);
			BufferedWriter bw = new BufferedWriter(writer);
			
			br = new BufferedReader(new FileReader(sourceFile));

			Boolean firstLine = true;
			while ((line = br.readLine()) != null) {
				System.out.println(line);
				if (!firstLine) {
					String[] features = line.split(csvSplitBy); //pocet clenu v jednom radku
					//ArrayList<Double> passwordLine = new ArrayList<Double>();
					
					for (int i = 0; i <= features.length - 1; i++) {
						Double num = null; 
						num = Double.parseDouble(features[i]);
						
						if(i >= features.length - 2) {
							//jedna se o posledni dve hodnoty, ktere urcuji classu. Ulozim sem 0 abych jednoznacne tohoto uzivatele poznal
							num = 0.0;
							//passwordLine.add(num);
							System.out.print(num + ",");
						}else{
							//jestlize se jedna o kazdou dalsi hodnotu pole
							//passwordLine.add(num);
							System.out.print(num + ",");
						}
						writer.append(BigDecimal.valueOf(num)
								.toPlainString());
						writer.append(',');
						
					}
					//passwordList.add(passwordLine);
					System.out.println('\n');
					writer.append('\n');
				}
				firstLine = false;
			}
			writer.flush();
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		System.out.println("Done");
		
		
		
	}
	
	
	// Dostat data z CSV do pole
	private ArrayList<ArrayList<Double>> readCSV(String source, String user) {
		ArrayList<ArrayList<Double>> passwordList = new ArrayList<ArrayList<Double>>();
		BufferedReader br = null;
		String line = "\n";
		String csvSplitBy = ",";

		System.out.println("Source: " + user);
		try {
			br = new BufferedReader(new FileReader(source));

			Boolean firstLine = true;
			while ((line = br.readLine()) != null) {

				if (!firstLine) {
					String[] features = line.split(csvSplitBy);
					ArrayList<Double> password = new ArrayList<Double>();
					
					for (int i = 0; i < features.length - 1; i++) {
						Double num = null; 
						num = Double.parseDouble(features[i]);
						if(num != null) {
							System.out.print(num + ", ");
						}
						if(i == 0) {
							//jedna se o prvni hodnotu, ktera je vzdy nula - vyuziju ji pro definici usera.
							if(user == userH) {
								password.add(1.0);
							}
							if(user == userA) {
								password.add(2.0);
							}
							if(user == userM) {
								password.add(3.0);
							}
						}else{
							//jestlize se jedna o kazdou dalsi hodnotu pole
							password.add(num);
						}
						
					}
					passwordList.add(password);
					System.out.println('\n');
				}
				firstLine = false;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		System.out.println("Done");
		return passwordList;

	}

	private void generateCsvFile(ArrayList<ArrayList<Double>> pwList,
			String target) {

		try {
			FileWriter writer = new FileWriter(target);
			
			if(resit_moji_metodou) {
				//Generate headers - pokud resim moji metodou. Ta automaticka nechce Headers
				ArrayList<Double> p = pwList.get(0);
				int numOfIterations = p.size() / 2 - 1;
				for (int i = 0; i <= numOfIterations; i++) {
					writer.append("FT" + i);
					writer.append(',');
					writer.append("DT" + i);
					// pokud se jedna o posledni znak
					if (i == numOfIterations) {
						writer.append(',');
						writer.append("User");
					} else {
						writer.append(',');
					}
				}
				writer.append('\n');
			}
			
			for (ArrayList<Double> password : pwList) {
				
				double user = password.get(0);
				for (int i = 0; i < password.size(); i++) {
		
					if (i == 0) {
						//pokud se jedna o prvni znak - vratime hodnotu prvniho znaku na 0
						writer.append(BigDecimal.valueOf(0.0)
								.toPlainString());
						writer.append(',');
					} else {
						//pokud se jedna o jakykoliv dalsi znak
						writer.append(BigDecimal.valueOf(password.get(i))
								.toPlainString());
						writer.append(',');
						
						if (i == password.size() - 1) {
							// pokud se jeste ke vsemu jedna o posledni znak
							if(user == 1.0) {
								writer.append(userH);
							}
							if(user == 2.0) {
								writer.append(userA);
							}
							if(user == 3.0) {
								writer.append(userM);
							}
							
							
						}
					}
										
				}
				writer.append('\n');
				
			}


			writer.flush();
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	
}
